VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsNtCompress"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ************************************************************
' Copyright  1999-2000 Slightly Tilted Software
' All rights reserved
' You're absolutely free to use these resources within your
'     own applications, but you may not redistribute them
'     (as source) in any manner whatsoever, whether for profit
'     or not.
' The only legitimate source for the original source code is
'     at the Ask The NT Pro site and my own web site at:
'     http://www.SlightlyTiltedSoftware.com
' ************************************************************
Option Explicit
Option Compare Text
Option Base 0
DefLng A-Z

' ---------------------------------------------
' Volume information (to determine if NTFS vol)
' ---------------------------------------------
Private Declare Function GetVolumeInformation _
   Lib "kernel32" Alias "GetVolumeInformationA" _
   (ByVal lpRootPathName As String, _
    ByVal lpVolumeNameBuffer As String, _
    ByVal nVolumeNameSize As Long, _
    lpVolumeSerialNumber As Long, _
    lpMaximumComponentLength As Long, _
    lpFileSystemFlags As Long, _
    ByVal lpFileSystemNameBuffer As String, _
    ByVal nFileSystemNameSize As Long) As Long

' ---------------------------------------------
' Get a file's attributes
' ---------------------------------------------
Private Declare Function GetFileAttributes _
   Lib "kernel32" Alias "GetFileAttributesA" _
   (ByVal lpFileName As String) As Long

' ---------------------------------------------
'
' ---------------------------------------------
Private Declare Function DeviceIoControl _
   Lib "kernel32" _
   (ByVal hDevice As Long, _
    ByVal dwIoControlCode As Long, _
    lpInBuffer As Integer, _
    ByVal nInBufferSize As Integer, _
    lpOutBuffer As Long, _
    ByVal nOutBufferSize As Long, _
    lpBytesReturned As Long, _
    ByVal lpOverlapped As Any) As Long
Private Declare Function CreateFile _
   Lib "kernel32" Alias "CreateFileA" _
   (ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Long, _
    ByVal dwShareMode As Long, _
    ByVal lpSecurityAttributes As Any, _
    ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, _
    ByVal hTemplateFile As Long) As Long
Private Declare Function CloseHandle _
   Lib "kernel32" _
   (ByVal hObject As Long) As Long

Private FSCTL_GET_COMPRESSION          As Long
Private FSCTL_SET_COMPRESSION          As Long

Private Const FILE_FLAG_BACKUP_SEMANTICS  As Long = &H2000000
Private Const FILE_ATTRIBUTE_COMPRESSED   As Long = &H800
Private Const FILE_READ_DATA              As Long = &H1&
Private Const FILE_WRITE_DATA             As Long = &H2&
Private Const FILE_DEVICE_FILE_SYSTEM     As Long = &H9&
Private Const METHOD_BUFFERED             As Long = 0&
Private Const FILE_ANY_ACCESS             As Long = 0&
Private Const COMPRESSION_FORMAT_NONE     As Long = 0&
Private Const COMPRESSION_FORMAT_DEFAULT  As Long = 1&
Private Const GENERIC_READ             As Long = &H80000000
Private Const GENERIC_WRITE            As Long = &H40000000
Private Const GENERIC_EXECUTE          As Long = &H20000000
Private Const GENERIC_ALL              As Long = &H10000000
Private Const FILE_SHARE_READ          As Long = &H1&
Private Const FILE_SHARE_WRITE         As Long = &H2&
Private Const FILE_SHARE_DELETE        As Long = &H4&
Private Const CREATE_NEW               As Long = 1&
Private Const CREATE_ALWAYS            As Long = 2&
Private Const OPEN_EXISTING            As Long = 3&
Private Const OPEN_ALWAYS              As Long = 4&
Private Const TRUNCATE_EXISTING        As Long = 5&
Private Const INVALID_HANDLE_VALUE     As Long = -1&

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Sub SetCompression
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 09/09/2000 -- 15:33:45
' Inputs       : ByVal xi_blnSetCompression:Boolean -
'              : ByVal xi_strFileName:String -
' Outputs      : N/A
' Description  : Set or unset compression on a specific
'              :     directory or file on a NTFS volume
' --------------------------------------------------------
' Thanks to fellow MVP's Brad Martinez and Klaus Probst
'                for helping me with the declarations.
' *******************************************************
Public Sub SetCompression(ByVal xi_blnIsCompressed As Boolean, _
                          ByVal xi_strFileName As String)
   Dim p_lngRtn                        As Long
   Dim p_lngFileHwnd                   As Long
   Dim p_lngBytesRtn                   As Long
   
   ' NOTE: If you do only files, not directories,
   '       then the dwFlagsAndAttributes can be
   '       set to 0&
   p_lngFileHwnd = CreateFile(lpFileName:=xi_strFileName, _
                              dwDesiredAccess:=GENERIC_ALL, _
                              dwShareMode:=FILE_SHARE_WRITE And FILE_SHARE_READ, _
                              lpSecurityAttributes:=0&, _
                              dwCreationDisposition:=OPEN_EXISTING, _
                              dwFlagsAndAttributes:=FILE_FLAG_BACKUP_SEMANTICS, _
                              hTemplateFile:=0&)
   If p_lngFileHwnd <> INVALID_HANDLE_VALUE Then
      ' Everything is OK
   Else
      Err.Raise Description:="Could not open file/directory name: " & xi_strFileName & vbCrLf & "Error: " & Err.LastDllError, _
                Number:=9999, _
                Source:="clsNtCompress.SetCompression"
   End If

   If xi_blnIsCompressed = False Then
      p_lngRtn = DeviceIoControl(hDevice:=p_lngFileHwnd, _
                                 dwIoControlCode:=FSCTL_SET_COMPRESSION, _
                                 lpInBuffer:=COMPRESSION_FORMAT_DEFAULT, _
                                 nInBufferSize:=2&, _
                                 lpOutBuffer:=0&, _
                                 nOutBufferSize:=0&, _
                                 lpBytesReturned:=p_lngBytesRtn, _
                                 lpOverlapped:=0&)
   ElseIf xi_blnIsCompressed = True Then
      p_lngRtn = DeviceIoControl(hDevice:=p_lngFileHwnd, _
                                 dwIoControlCode:=FSCTL_SET_COMPRESSION, _
                                 lpInBuffer:=COMPRESSION_FORMAT_NONE, _
                                 nInBufferSize:=2&, _
                                 lpOutBuffer:=0&, _
                                 nOutBufferSize:=0&, _
                                 lpBytesReturned:=p_lngBytesRtn, _
                                 lpOverlapped:=0&)
   End If
   
   If p_lngRtn = 0 Then
      If xi_blnIsCompressed = True Then
         Err.Raise Description:="Compression failed for: " & xi_strFileName, _
                   Number:=9999, _
                   Source:="clsNtCompress.SetCompression"
      Else
         Err.Raise Description:="Decompression failed for: " & xi_strFileName, _
                   Number:=9999, _
                   Source:="clsNtCompress.SetCompression"
      End If
   End If

   p_lngRtn = CloseHandle(hObject:=p_lngFileHwnd)

End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Function IsCompressed
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 09/09/2000 -- 15:48:20
' Inputs       : ByVal xi_strFullPath:String -
' Outputs      : Boolean --
' Description  : Returns whether the current file is
'              :     currently compressed or not
' *******************************************************
Public Function IsCompressed(ByVal xi_strFullPath As String) As Boolean
   Dim p_lngRtn                        As Long
   
   p_lngRtn = GetFileAttributes(lpFileName:=xi_strFullPath)
 
   If p_lngRtn And FILE_ATTRIBUTE_COMPRESSED Then
      IsCompressed = True
   Else
      IsCompressed = False
   End If

End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Function IsNTFS
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 11/28/1998 -- 17:47:14
' Inputs       : ByVal xi_strFilePath:String - Full path name of file
' Outputs      : Boolean: TRUE if on NTFS, FALSE otherwise
' Description  : Pass the full path name of a file, return
'              :     whether or not this file is on a
'              :     NTFS volume
' *******************************************************
Public Function IsNTFS(ByVal xi_strFilePath As String) As Boolean
   Dim p_strVolBuffer                  As String
   Dim p_strSystemName                 As String
   Dim p_strVol                        As String
   Dim p_lngSerialNum                  As Long
   Dim p_lngSystemFlags                As Long
   Dim p_lngComponentLen               As Long
   Dim p_lngRtn                        As Long
   
   p_strVolBuffer = String$(256, 0)
   p_strSystemName = String$(256, 0)
   p_strVol = UCase$(Mid$(xi_strFilePath, 1, 3))
   p_lngRtn = GetVolumeInformation(p_strVol, _
                                   p_strVolBuffer, _
                                   Len(p_strVolBuffer) - 1, _
                                   p_lngSerialNum, _
                                   p_lngComponentLen, _
                                   p_lngSystemFlags, _
                                   p_strSystemName, _
                                   Len(p_strSystemName) - 1)
   If p_lngRtn = 0 Then
      IsNTFS = False
   Else
      If UCase$(Mid$(p_strSystemName, 1, 4)) = "NTFS" Then
         IsNTFS = True
      Else
         IsNTFS = False
      End If
   End If

End Function

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Function GetCtlCode
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 09/09/2000 -- 15:03:29
' Inputs       : ByVal xi_lngDeviceType:Long -
'              : ByVal xi_lngFunction:Long -
'              : ByVal xi_lngMethod:Long -
'              : ByVal xi_lngAccess:Long -
' Outputs      : Long -- The final control code to use
' Description  : Encapsulates the rather ugly way that
'              :     you have to calculate the control code
'              :     in order to get and set NT file compression
' *******************************************************
Private Function GetCtlCode(ByVal xi_lngDeviceType As Long, _
                            ByVal xi_lngFunction As Long, _
                            ByVal xi_lngMethod As Long, _
                            ByVal xi_lngAccess As Long) As Long
   GetCtlCode = (CLng(xi_lngDeviceType) * (2 ^ 16)) Or _
                (CLng(xi_lngAccess) * (2 ^ 14)) Or _
                (CLng(xi_lngFunction) * (2 ^ 2)) Or _
                 xi_lngMethod
End Function

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Sub Class_Initialize
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 09/09/2000 -- 15:01:57
' Inputs       : N/A
' Outputs      : N/A
' Description  : On initialization, set the two variables
'              :     for Get and Set compression
' *******************************************************
Private Sub Class_Initialize()
   FSCTL_GET_COMPRESSION = GetCtlCode(xi_lngDeviceType:=FILE_DEVICE_FILE_SYSTEM, _
                                      xi_lngFunction:=15, _
                                      xi_lngMethod:=METHOD_BUFFERED, _
                                      xi_lngAccess:=FILE_ANY_ACCESS)
   FSCTL_SET_COMPRESSION = GetCtlCode(xi_lngDeviceType:=FILE_DEVICE_FILE_SYSTEM, _
                                      xi_lngFunction:=16, _
                                      xi_lngMethod:=METHOD_BUFFERED, _
                                      xi_lngAccess:=FILE_READ_DATA Or _
                                                    FILE_WRITE_DATA)
End Sub
